
#include <stdio.h>

int main(int argc, char **argv)
{
	int i;

	printf("\n");
	printf("package com.sreal.visiprox;\n");
	printf("\n");
	printf("public class FormatConverter\n");
	printf("{\n");
	printf("\tpublic static java.lang.String[] byte_to_hex_string_array =\n"); 
	printf("\t{\n");

	for (i = 0; i <= 0xFF; i++)
	{
		printf("\t\t\"%02X \"%s\n", i, i == 0xFF ? "" : ",");
	}

	printf("\t};\n");
	printf("\n");
	printf("\tpublic static java.lang.String[] byte_to_mixed_string_array =\n"); 
	printf("\t{\n");

	for (i = 0; i < 0x21; i++)
	{
		printf("\t\t\"%02X \",\n", i);
	}

	for (i = 0x21; i < 0x7F; i++)
	{
		printf("\t\t\"%s%c  \",\n", ((i == 0x22) || (i == 0x27) || (i == 0x5C)) ? "\\" : "", (char)(i));
	}

	for (i = 0x7F; i <= 0xFF; i++)
	{
		printf("\t\t\"%02X \"%s\n", i, i == 0xFF ? "" : ",");
	}

	printf("\t};\n");
	printf("\n");
	printf("\tpublic static int unsignedByteToInt(byte b)\n");
	printf("\t{\n");
	printf("\t\tint i = (int)(b);\n");
	printf("\t\treturn i < 0 ? i + 256 : i;\n");
	printf("\t}\n");
	printf("\n");
	printf("\tpublic static java.lang.String byteToHexString(byte b)\n");
	printf("\t{\n");
	printf("\t\treturn byte_to_hex_string_array[unsignedByteToInt(b)];\n");
	printf("\t}\n");
	printf("\n");
	printf("\tpublic static java.lang.String byteToMixedString(byte b)\n");
	printf("\t{\n");
	printf("\t\treturn byte_to_mixed_string_array[unsignedByteToInt(b)];\n");
	printf("\t}\n");
	printf("}\n");
	printf("\n");

	return 0;
}

